<?php 
// Graph Explorer Component
//
// Copyright (c) 2010 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: graphexplorer.inc.php 155 2010-11-06 02:36:00Z egalstad $

require_once(dirname(__FILE__).'/../componenthelper.inc.php');

include_once(dirname(__FILE__).'/dashlet.inc.php');

// respect the name
$graphexplorer_component_name="graphexplorer";

// run the initialization function
graphexplorer_component_init();

////////////////////////////////////////////////////////////////////////
// COMPONENT INIT FUNCTIONS
////////////////////////////////////////////////////////////////////////

function graphexplorer_component_init(){
	global $graphexplorer_component_name;
	
	$versionok=graphexplorer_component_checkversion();
	
	$desc="Nagios Graph Explorer is an interactive graphing tool for your Nagios data. Requires Nagios XI 2011R1.3 or later.
			For most reliable graphs and dashlets, use Mozilla Firefox.";
	if(!$versionok)
		$desc="<b>Error: This component requires Nagios XI 20011R1 or later.</b>";
	
	$args=array(

		// need a name
		COMPONENT_NAME => $graphexplorer_component_name,
		
		// informative information
		COMPONENT_AUTHOR => "Mike Guthrie, Nagios Enterprises, LLC",
		COMPONENT_DESCRIPTION => $desc,
		COMPONENT_TITLE => "Nagios Graph Explorer",
		COMPONENT_DATE => '07/12/2012',
		COMPONENT_VERSION => '1.4',
		// configuration function (optional)
		//COMPONENT_CONFIGFUNCTION => "graphexplorer_component_config_func",
		);
		
	register_component($graphexplorer_component_name,$args);
	
	// add a menu link
	if($versionok)
		register_callback(CALLBACK_MENUS_INITIALIZED,'graphexplorer_component_addmenu');
		
	// register a dashlet
	$args=array();
	$args[DASHLET_NAME]="graphexplorer";
	$args[DASHLET_TITLE]="Graph Explorer";
	$args[DASHLET_FUNCTION]="graphexplorer_dashlet_func";
	$args[DASHLET_DESCRIPTION]="Displays a graph explorer dashlet.";
	$args[DASHLET_WIDTH]="500";
	$args[DASHLET_HEIGHT]="450";
	$args[DASHLET_INBOARD_CLASS]="graphexplorer_map_inboard";
	$args[DASHLET_OUTBOARD_CLASS]="graphexplorer_map_outboard";
	$args[DASHLET_CLASS]="graphexplorer_map";
	$args[DASHLET_AUTHOR]="Nagios Enterprises, LLC";
	$args[DASHLET_COPYRIGHT]="Dashlet Copyright &copy; 2011 Nagios Enterprises. All rights reserved.";
	$args[DASHLET_HOMEPAGE]="http://www.nagios.com";
	$args[DASHLET_SHOWASAVAILABLE]=false;
	register_dashlet($args[DASHLET_NAME],$args);
	}
	



///////////////////////////////////////////////////////////////////////////////////////////
// MISC FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////

function graphexplorer_component_checkversion(){

	if(!function_exists('get_product_release'))
		return false;
	//requires greater than 2009R1.4B
	if(get_product_release()<200)
		return false;

	return true;
	}
	
function graphexplorer_component_addmenu($arg=null){
	global $graphexplorer_component_name;
	
	$mi=find_menu_item(MENU_HOME,"menu-home-all-host-graphs","id");
	if($mi==null)
		return;
		
	$order=grab_array_var($mi,"order","");
	if($order=="")
		return;
		
	$neworder=$order+0.1;
	
/*	add_menu_item(MENU_HOME,array(
		"type" => "linkspacer",
		"order" => $neworder,
		));
*/
		
	$neworder=$order+0.1;
	
	add_menu_item(MENU_HOME,array(
		"type" => "link",
		"title" => "Graph Explorer",
		"id" => "menu-home-graphexplorer",
		"order" => $neworder,
		"opts" => array(
			"href" => get_base_url().'includes/components/graphexplorer/',
			//"target" => "_blank",  
			)
		));
	
	}
	
?>